﻿Imports System.Web
Imports Telerik.OpenAccess

Public Class ScopeFactory
    Private Const SCOPE_KEY As String = "ContextScopeKey"

    Public Shared Function GetScope(ByVal context As HttpContext) As IObjectScope
        Dim scope As IObjectScope
        If context Is Nothing Then
            scope = ObjectScopeProvider1.GetNewObjectScope()
        Else
            scope = TryCast(context.Items(SCOPE_KEY), IObjectScope)
            If scope Is Nothing Then
                scope = ObjectScopeProvider1.GetNewObjectScope()
                context.Items(SCOPE_KEY) = scope
            End If
        End If

        Return scope
    End Function
End Class